module Putter
  class WatcherData
    attr_accessor :label, :proxy_methods

    def initialize(options, klass)
      @label = set_label(options[:label], klass)
      @proxy_methods = set_methods(options[:methods], klass.singleton_class)
    end

    def set_label(label, klass)
      if !label.nil? && label != ""
        label
      else
        klass.name
      end
    end

    def set_methods(methods, singleton_klass)
      if methods.nil?
        methods_to_proxy(singleton_klass)
      elsif !methods.is_a?(Array)
        [methods]
      else
        methods
      end
    end

    def methods_to_proxy(singleton_klass)
      ignored_methods = Putter.configuration.methods_denylist.map(&:to_sym)

      Putter.configuration.ignore_methods_from.each do |klass|
        ignored_methods += klass.methods
      end

      allowlist = Putter.configuration.methods_allowlist.map(&:to_sym) + [:new]

      singleton_klass.instance_methods - ignored_methods + allowlist
    end
  end
end
